#include <stdio.h>

typedef long long LL;

int inverse(int a, int m, int *gcd)
{
	int p0, p1 = 0, p2 = 1, r0, r1 = m, r2 = a%m+(a<0?m:0);
	while (r2) {
		r0 = r1; r1 = r2; r2 = r0%r1;
		p0 = p1; p1 = p2; p2 = (int)((p0-r0/r1*(LL)p1)%m);
	}
	if (gcd) *gcd = r1;
	while (p1 < 0) p1 += m;
	while (p1 >= m) p1 -= m;
	return p1;
}

int ceq(int a, int b, int m, int *newm)
{
	int inva, gcd;
	inva = inverse(a, m, &gcd);
	if (b%gcd) return -1;
	b = b%m;
	if (b < 0) b += m;
	if (newm) *newm = m/gcd;
	return (int)((LL)inva*(b/gcd)%(m/gcd));
}

int ceq2(int b1, int m1, int b2, int m2, int *m)
{
	int m0, y;
	b1 = b1%m1+(b1<0?m1:0);
	y = ceq(m1, b2-b1, m2, &m0);
	if (y == -1) return -1;
	if (m) *m = m0*m1;
	return m1*y+b1;
}

int pl[10];
int t[1200][10][10];
int mod[10];

int main(void)
{
	for (;;) {
		int n, i, j, k, l, m, w;
		scanf("%d", &n);
		if (n == 0) return 0;
		for (i = 0; i < n; i++) {
			for (j = 1; j <= 5; j++) {
				for (k = 1; k <= 5; k++) {
					t[i][j][k] = -1;
				}
			}
		}
		for (i = 1; i <= 5*n; i++) {
			int x;
			scanf("%d", &x);
			if (x <= 5) pl[x] = i;
		}
		for (i = 1; i <= 5; i++) {
			m = pl[i];
			for(j = 0;; j++) {
				int a, b;
				a = (m-1)/5;
				b = m-5*a;
				t[a][i][b] = j;
				if (b == 1 || b == 2) m = 2*a+b;
				else if (b == 3 || b == 4) m = 2*n+2*a+b-2;
				else m = 4*n+a+b-4;
				if (m == pl[i]) {
					mod[i] = j+1;
					break;
				}
			}
		}
		m = -1;
		for (i = 0; i < n; i++) {
			int a[6];
			for (a[1] = 1; a[1] <= 5; a[1]++) {
			if (t[i][1][a[1]] == -1) continue;
			for (a[2] = 1; a[2] <= 5; a[2]++) {
			if (t[i][2][a[2]] == -1) continue;
			for (a[3] = 1; a[3] <= 5; a[3]++) {
			if (t[i][3][a[3]] == -1) continue;
			for (a[4] = 1; a[4] <= 5; a[4]++) {
			if (t[i][4][a[4]] == -1) continue;
			for (a[5] = 1; a[5] <= 5; a[5]++) {
			if (t[i][5][a[5]] == -1) continue;
				int b = t[i][1][a[1]], m = mod[1];
printf("%d %d %d %d %d\n", a[1], a[2], a[3], a[4], a[5]);				
printf("%d %d, %d %d, %d %d, %d %d, %d %d\n", t[i][1][a[1]], mod[1], t[i][2][a[2]], mod[2], t[i][3][a[3]], mod[3], t[i][4][a[4]], mod[4], t[i][5][a[5]], mod[5]);
				b = ceq2(b, m, t[i][2][a[2]], mod[2], &m);
				if (b == -1) continue;
				b = ceq2(b, m, t[i][3][a[3]], mod[3], &m);
				if (b == -1) continue;
				b = ceq2(b, m, t[i][4][a[4]], mod[4], &m);
				if (b == -1) continue;
				b = ceq2(b, m, t[i][5][a[5]], mod[5], &m);
				if (b == -1) continue;
				if (m == -1 || b < m) {
					m = b;
					w = i;
				}
			}
			}
			}
			}
			}
		}
		if (m == -1) printf("Neverending game.\n");
		else printf("Player %d wins game number %d.\n", w+1, m+1);
	}
}
